/* Copyright (C) 1991, 1992 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include <ansidecl.h>
#include <string.h>


void bcopy (const __ptr_t src, __ptr_t dest, int len)
{

/*
 * Under Alpha/Linux, we want guaranteed results more so than fast ones (hey
 * we have the speed of Alpha!).  3/7/95, bjn.
 */

#if defined(__alpha__) && defined(__linux__)
    memmove(dest, src, len);
#else
    memcpy(dest, src, len);
#endif
}

