/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: strlen.S,v $
# Revision 1.1  1994/04/01  19:52:09  paradis
# Initial revision
#
 * Revision 1.1.2.4  1993/01/19  14:06:21  Ken_Lesniak
 * 	add .prologue directive
 * 	[93/01/08  17:19:43  Ken_Lesniak]
 *
 * Revision 1.1.2.3  92/06/16  10:17:36  Ken_Lesniak
 * 	cosmetic changes
 * 	[92/06/16  10:16:35  Ken_Lesniak]
 * 
 * Revision 1.1.2.2  92/05/26  09:16:01  Ken_Lesniak
 * 	first pass at assembly lang version of strlen
 * 	[92/05/26  09:14:01  Ken_Lesniak]
 * 
 * $EndLog$
 */

#include <linux/alpha/regdef.h>

/*
 * extern size_t strlen(char *s);
 *
 *	a0	string address (s)
 *
 * Return the number of bytes in the string pointed to by the "s" parameter.
 * The string length value does not include the terminating null character.
 */
	.globl	strlen
	.ent	strlen
strlen:

	ldq_u	t0, 0(a0)		# get first quad
	ldiq	t1, -1			# get a quad of all 0xff bytes
	insqh	t1, a0, t1		# build mask of bytes to ignore
	bic	a0, 7, v0		# get aligned string pointer
	bis	t0, t1, t0		# set ignored bytes of first QW to 0xff
	cmpbge	zero, t0, t1		# any null bytes?
	bne	t1, 20f			# br if so

	.align	3
10:	ldq	t0, 8(v0)		# get next 8 bytes
	addq	v0, 8, v0		# advance string pointer
	cmpbge	zero, t0, t1		# any null bytes?
	beq	t1, 10b			# keep looping if not

	.align	3
20:	subq	zero, t1, t2		# complement bits to left of first 1-bit
	blbs	t1, 30f			# exit if null in first byte

	and	t1, t2, t1		# remove all but first 1-bit

	and	t1, 0x0f, t2		# null in bytes 0..3?
	addq	v0, 4, t0		# adjust pointer assuming no
	cmoveq	t2, t0, v0		# if no, replace pointer
	and	t1, 0x33, t3		# null in bytes 0..1, or 4..5?
	addq	v0, 2, t0		# adjust pointer assuming no
	cmoveq	t3, t0, v0		# if no, replace pointer
	and	t1, 0x55, t4		# null in bytes 0, 2, 4 of 6
	addq	v0, 1, t0		# adjust pointer assuming no
	cmoveq	t4, t0, v0		# if no, replace pointer

30:	subq	v0, a0, v0		# get length of string
	ret	zero,(ra)
	.end	strlen
