/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: __divlu.s,v $
 * Revision 1.2.2.11  1993/01/19  15:27:47  Ken_Lesniak
 * 	make sure result is in 32-bit canonical form on return
 * 	[93/01/15  10:45:45  Ken_Lesniak]
 *
 * Revision 1.2.2.10  92/12/22  14:33:40  Ken_Lesniak
 * 	fixup prolog and register usage to work with exception handling.
 * 	modify divide by zero trap to return 0 if continued
 * 	[92/12/21  11:39:38  Ken_Lesniak]
 * 
 * Revision 1.2.2.9  92/11/04  15:31:47  Ken_Lesniak
 * 	total re-write
 * 	[92/11/04  14:45:11  Ken_Lesniak]
 * 
 * Revision 1.2.2.8  92/08/26  10:48:58  Ken_Lesniak
 * 	return result in $27
 * 	[92/08/26  10:25:22  Ken_Lesniak]
 * 
 * Revision 1.2.2.7  92/06/11  08:42:01  Mike_Rickabaugh
 * 	Updated divide/mod routines to use registers , , and .
 * 	[92/06/11  08:36:49  Mike_Rickabaugh]
 * 
 * Revision 1.2.2.6  92/04/13  14:58:47  Mike_Rickabaugh
 * 	Altered divide and friends to be prepared for both calling standards.
 * 	[92/04/13  14:55:36  Mike_Rickabaugh]
 * 
 * Revision 1.2.2.5  92/03/04  12:03:20  Brett_Sampson
 * 	actually changed the save mask
 * 	[92/03/04  12:02:46  Brett_Sampson]
 * 
 * Revision 1.2.2.4  92/03/04  11:59:06  Brett_Sampson
 * 	fixed register mask to represent saving
 * 	t4 also fixed typo so t4 would be restored
 * 	[92/03/04  11:58:25  Brett_Sampson]
 * 
 * Revision 1.2.2.3  92/03/03  20:09:32  Brett_Sampson
 * 	Save register t4 over the divide operation.
 * 	[92/03/03  20:06:39  Brett_Sampson]
 * 
 * Revision 1.2.2.2  92/02/20  17:02:44  Mike_Rickabaugh
 * 	Initial 3.10 version.
 * 	[92/02/20  16:33:05  Mike_Rickabaugh]
 * 
 * $EndLog$
 */

/*
 * Unsigned division
 *
 * On input:
 *	$23/t9  = return address (RA)
 *	$24/t10 = dividend (numerator) (A)
 *	$25/t11 = divisor (denominator) (B)
 *	Note that the high 32 bits of r24 and r25 are ignored.
 *
 * On Return:
 *	$27/t12 = quotient (Q)
 *	All other registers, except $at and $gp, must be preserved
 */

#define ENTRY \
	.globl	__divlu; \
	.ent	__divlu; \
__divlu: ; \
	ldgp	gp, 0(pv); \
	lda	sp, -8*8(sp); \
	stq	RA, 0*8(sp); \
	stq	t0, 1*8(sp); \
	stq	t1, 2*8(sp); \
	stq	t2, 3*8(sp); \
	stq	t3, 4*8(sp); \
	stq	a0, 5*8(sp); \
	stq	A, 6*8(sp); \
	stq	B, 7*8(sp); \
	.prologue 1; \
	zap	A, 0xf0, A; \
	zap	B, 0xf0, B

#define UNSIGNED 1

#define THIRTYTWOBIT 1

#define RETURN \
	addl	Q, 0, Q; \
	ldq	RA, 0*8(sp); \
	ldq	t0, 1*8(sp); \
	ldq	t1, 2*8(sp); \
	ldq	t2, 3*8(sp); \
	ldq	t3, 4*8(sp); \
	ldq	a0, 5*8(sp); \
	ldq	A, 6*8(sp); \
	ldq	B, 7*8(sp); \
	lda	sp, 8*8(sp); \
	ret	zero, (RA), 1

#define END \
	.end	__divlu

#include "divrem.S"
