/* __htonl and __htons: functions to convert native byte ordering
 * to network byte ordering.  Because canonical network byte-ordering
 * is big-endian, we need to do byte-swaps here.  Fortunately, we're
 * good at this 8-) 
 */

#include <linux/alpha/pal.h>
#include <linux/alpha/regdef.h>

	.globl	__htonl
	.ent	__htonl
__htonl:
	bis	a0,a0,v0	# v0 is result; swap in-place.  v0=aabbccdd
	extlh	v0,5,t1		# t1 = dd000000
	zap	v0,0xfd,t2	# t2 = 0000cc00
	sll	t2,5,t2		# t2 = 00198000
	s8addl	t2,t1,t1	# t1 = ddcc0000
	zap	v0,0xfb,t2	# t2 = 00bb0000
	srl	t2,8,t2		# t2 = 0000bb00
	extbl	v0,3,v0		# v0 = 000000aa
	or	t1,v0,v0	# v0 = ddcc00aa
	or	t2,v0,v0	# v0 = ddccbbaa
	ret	zero,(ra)
	.end	__htonl

	.globl	__htons
	.ent	__htons
__htons:
	bis	a0,a0,v0	# v0 is result; swap in-place.  v0=aabb
	extwh	v0,7,t1	# t1 = bb00
	extbl	v0,1,v0	# v0 = 00aa
	bis	v0,t1,v0	# v0 = bbaa
	ret	zero,(ra)
	.end	__htons
