/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: __remqu.s,v $
 * Revision 1.1.2.7  1992/12/22  14:34:24  Ken_Lesniak
 * 	fixup prolog and register usage to work with exception handling.
 * 	modify divide by zero trap to return 0 if continued
 * 	[92/12/21  11:40:44  Ken_Lesniak]
 *
 * Revision 1.1.2.6  92/11/04  15:32:41  Ken_Lesniak
 * 	total re-write
 * 	[92/11/04  14:48:07  Ken_Lesniak]
 * 
 * Revision 1.1.2.5  92/08/26  10:49:39  Ken_Lesniak
 * 	return results in $27
 * 	[92/08/26  10:37:54  Ken_Lesniak]
 * 
 * Revision 1.1.2.4  92/06/11  08:43:27  Mike_Rickabaugh
 * 	Updated divide/mod routines to use registers , , and .
 * 	[92/06/11  08:38:17  Mike_Rickabaugh]
 * 
 * Revision 1.1.2.3  92/04/13  14:59:48  Mike_Rickabaugh
 * 	Altered divide and friends to be prepared for both calling standards.
 * 	[92/04/13  14:56:40  Mike_Rickabaugh]
 * 
 * Revision 1.1.2.2  92/02/20  17:04:36  Mike_Rickabaugh
 * 	Initial 3.10 version.
 * 	[92/02/20  16:51:19  Mike_Rickabaugh]
 * 
 * $EndLog$
 */

/*
 * Unsigned remainder
 *
 * On input:
 *	$23/t9  = return address (RA)
 *	$24/t10 = dividend (numerator) (A)
 *	$25/t11 = divisor (denominator) (B)
 *
 * On Return:
 *	$27/t12 = remainder (Q)
 *	All other registers, except $at and $gp, must be preserved
 */

#define ENTRY \
	.globl	__remqu; \
	.ent	__remqu; \
__remqu: ; \
	ldgp	gp, 0(pv); \
	lda	sp, -6*8(sp); \
	stq	RA, 0*8(sp); \
	stq	t0, 1*8(sp); \
	stq	t1, 2*8(sp); \
	stq	t2, 3*8(sp); \
	stq	t3, 4*8(sp); \
	stq	a0, 5*8(sp); \
	.prologue 1

#define UNSIGNED 1

#define REMAINDER 1

#define RETURN \
	ldq	RA, 0*8(sp); \
	ldq	t0, 1*8(sp); \
	ldq	t1, 2*8(sp); \
	ldq	t2, 3*8(sp); \
	ldq	t3, 4*8(sp); \
	ldq	a0, 5*8(sp); \
	lda	sp, 6*8(sp); \
	ret	zero, (RA), 1

#define END	\
	.end	__remqu

#include "divrem.S"
