#include <linux/alpha/alpha.h>
#include <linux/alpha/regdef.h>
#include <linux/alpha/pal.h>

/* Jump to the position specified by ENV, causing the
 * setjmp call there to return VAL, or 1 if VAL is 0. 
 * Usage:
 *	void __longjmp(jmp_buf *buf, int val)
 */

	.globl	__longjmp
	.ent	__longjmp
__longjmp:
	/* Squirrel away args/ra... */
	lda	sp,-24(sp)
	stq	ra,0(sp)
	stq	a0,8(sp)
	stq	a1,16(sp)

	/* Set signal mask */
	ldl	a0,528(a0)
	jsr	ra,sigsetmask

	ldq	a0,8(sp)
	ldq	a1,16(sp)

	/* Re-establish registers.  V0 gets set with whatever
	 * we specify, unless we specify zero.  In order to
	 * avoid ambiguity, we must always return nonzero to
	 * the caller of sigjmp...
	 *
	 * We load up t0 with the return PC.  sigjmp restores t0
	 * properly.
	 *
	 * Save a0 for last, for obvious reasons!
	 */
	bis	a1,a1,v0		# Set v0 to ret. val
	cmoveq	v0,1,a1			# If retval given as 0, use 1.
        ldq     $1,0(a0)                # R1 (t0) <- pc
        ldq     $2,32(a0)               # R2 (t1)
        ldq     $3,40(a0)               # R3 (t2)
        ldq     $4,48(a0)               # R4 (t3)
        ldq     $5,56(a0)               # R5 (t4)
        ldq     $6,64(a0)               # R6 (t5)
        ldq     $7,72(a0)               # R7 (t6)
        ldq     $8,80(a0)               # R8 (t7)
        ldq     $9,88(a0)               # R9 (s0)
        ldq     $10,96(a0)              # R10 (s1)
        ldq     $11,104(a0)             # R11 (s2)
        ldq     $12,112(a0)             # R12 (s3)
        ldq     $13,120(a0)             # R13 (s4)
        ldq     $14,128(a0)             # R14 (s5)
        ldq     $15,136(a0)             # R15 (FP)
        ldq     $17,152(a0)             # R17 (a1)
        ldq     $18,160(a0)             # R18 (a2)
        ldq     $19,168(a0)             # R19 (a3)
        ldq     $20,176(a0)             # R20 (a4)
        ldq     $21,184(a0)             # R21 (a5)
        ldq     $22,192(a0)             # R22 (t8)
        ldq     $23,200(a0)             # R23 (t9)
        ldq     $24,208(a0)             # R24 (t10)
        ldq     $25,216(a0)             # R25 (t11)
        ldq     $26,224(a0)             # R26 (ra)
        ldq     $27,232(a0)             # R27 (pv/t12)
        ldq     $28,240(a0)             # R28 (at)
        ldq     $29,248(a0)             # R29 (gp)
        ldq     $30,256(a0)             # R30 (sp)
        ldq     $31,264(a0)             # R31 (zero)
        ldt     $f0,272(a0)             # Floating regs...
        ldt     $f1,280(a0)
        ldt     $f2,288(a0)
        ldt     $f3,296(a0)
        ldt     $f4,304(a0)
        ldt     $f5,312(a0)
        ldt     $f6,320(a0)
        ldt     $f7,328(a0)
        ldt     $f8,336(a0)
        ldt     $f9,344(a0)
        ldt     $f10,352(a0)
        ldt     $f11,360(a0)
        ldt     $f12,368(a0)
        ldt     $f13,376(a0)
        ldt     $f14,384(a0)
        ldt     $f15,392(a0)
        ldt     $f16,400(a0)
        ldt     $f17,408(a0)
        ldt     $f18,416(a0)
        ldt     $f19,424(a0)
        ldt     $f20,432(a0)
        ldt     $f21,440(a0)
        ldt     $f22,448(a0)
        ldt     $f23,456(a0)
        ldt     $f24,464(a0)
        ldt     $f25,472(a0)
        ldt     $f26,480(a0)
        ldt     $f27,488(a0)
        ldt     $f28,496(a0)
        ldt     $f29,504(a0)
        ldt     $f30,512(a0)
        ldt     $f31,520(a0)
        ldq     $16,144(a0)             # R16 (a0)
	
	/* Now go back as though from a bad dream... */
	jmp	zero,(t0)
	.end	__longjmp
