#include <fcntl.h>
#include <errno.h>
#include <sys/syscall.h>
#include <stdarg.h>

int
__open(const char * filename, int flag, ...)
{
	int res;
	va_list arg;

	va_start(arg,flag);
#ifdef BROKEN_VARARGS
	/* JRP - dain-bramanged alpha va_start only groks beginning of list */
	va_arg(arg, char *);	/* filename */
	va_arg(arg, int);		/* flag */
#endif

	res = syscall(SYS_open, filename, flag, va_arg(arg, int));

	if (res>=0)
		return res;
	errno = -res;
	va_end(arg);
	return -1;
}
