/* Copyright (C) 1993  Olaf Flebbe
This file is part of the Linux C Library.

The Linux C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The Linux C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.  */

#include <linux/alpha/regdef.h>
#include <fpu_control.h>

/* Set floating-point unit control word.  Syntax is same as Intel/68K
 * version, but bit defs are different.
 *
 * void	__setfpucw(fpu_control_t fpu_control)
 *
 * if fpu_control is zero, then set to default; otherwise, set to specified
 * value (except for reserved bits)
 */

	.globl	__setfpucw
	.ent	__setfpucw

__setfpucw:
	lda	sp,-24(sp)	# Save space for ra, f0, & scratch
	stq	ra,0(sp)
	stt	$f0,8(sp)

	ldiq	t0,_FPU_DEFAULT
	cmoveq	a0,t0,a0	# a0 = fpu_control ? fpu_control : _FPU_DEFAULT

	trapb
	mf_fpcr	$f0		# Read FPCR
	trapb
	stt	$f0,16(sp)
	ldq	t0,16(sp)	# move into t0

	ldiq	t1,_FPU_RESERVED
	and	t0,t1,t0	# Set non-reserved bits in fpcr to zero
	bic	a0,t1,a0	# Mask reserved bits out of fpu_control
	bis	a0,t0,t0	# OR the two together

	stq	t0,16(sp)
	ldt	$f0,16(sp)	# Move fpcr value back into f0
	trapb
	mt_fpcr	$f0		# Set it.
	trapb

	ldt	$f0,8(sp)	# Restore f0 & ra
	ldq	ra,0(sp)
	lda	sp,24(sp)	

	ret	zero,(ra)

	.end	__setfpucw
