#include <linux/alpha/regdef.h>
#include <linux/alpha/pal.h>

/* Store the calling environment in ENV.  Return when first
 * called.  Return a nonzero value when we longjmp back to
 * this point.
 *
 * Usage: 
 *	retval = __setjmp(jmp_buf * buf)
 */


	.globl	__setjmp
	.ent	__setjmp
__setjmp:
	/* Save the integer and floating registers first... */
	stq     $0,16(a0)		# R0 (v0)
	stq     $1,24(a0)		# R1 (t0) 
	stq     $2,32(a0)		# R2 (t1)
	stq     $3,40(a0)		# R3 (t2)
	stq     $4,48(a0)		# R4 (t3)
	stq     $5,56(a0)		# R5 (t4)
	stq     $6,64(a0)		# R6 (t5)
	stq     $7,72(a0)		# R7 (t6)
	stq     $8,80(a0)		# R8 (t7)
	stq     $9,88(a0)		# R9 (s0)
	stq     $10,96(a0)		# R10 (s1)
	stq     $11,104(a0)		# R11 (s2)
	stq     $12,112(a0)		# R12 (s3)
	stq     $13,120(a0)		# R13 (s4)
	stq     $14,128(a0)		# R14 (s5)
	stq     $15,136(a0)		# R15 (FP)
	stq     $16,144(a0)		# R16 (a0)
	stq     $17,152(a0)		# R17 (a1)
	stq     $18,160(a0)		# R18 (a2)
	stq     $19,168(a0)		# R19 (a3)
	stq     $20,176(a0)		# R20 (a4)
	stq     $21,184(a0)		# R21 (a5)
	stq     $22,192(a0)		# R22 (t8)
	stq     $23,200(a0)		# R23 (t9)
	stq     $24,208(a0)		# R24 (t10)
	stq     $25,216(a0)		# R25 (t11)
	stq     $26,224(a0)		# R26 (ra)
	stq     $27,232(a0)		# R27 (pv/t12)
	stq     $28,240(a0)		# R28 (at)
	stq     $29,248(a0)		# R29 (gp)
	stq     $30,256(a0)		# R30 (sp)
	stq     $31,264(a0)		# R31 (zero)
	stt     $f0,272(a0)		# Floating regs...
	stt     $f1,280(a0)
	stt     $f2,288(a0)
	stt     $f3,296(a0)
	stt     $f4,304(a0)
	stt     $f5,312(a0)
	stt     $f6,320(a0)
	stt     $f7,328(a0)
	stt     $f8,336(a0)
	stt     $f9,344(a0)
	stt     $f10,352(a0)
	stt     $f11,360(a0)
	stt     $f12,368(a0)
	stt     $f13,376(a0)
	stt     $f14,384(a0)
	stt     $f15,392(a0)
	stt     $f16,400(a0)
	stt     $f17,408(a0)
	stt     $f18,416(a0)
	stt     $f19,424(a0)
	stt     $f20,432(a0)
	stt     $f21,440(a0)
	stt     $f22,448(a0)
	stt     $f23,456(a0)
	stt     $f24,464(a0)
	stt     $f25,472(a0)
	stt     $f26,480(a0)
	stt     $f27,488(a0)
	stt     $f28,496(a0)
	stt     $f29,504(a0)
	stt     $f30,512(a0)
	stt     $f31,520(a0)
	lda	t0,8(zero)
	stq	t0,8(a0)			# PS - Must be 8 in user mode!
	bis	zero,zero,v0			# Set return value to 0
						# (branches will set it to
						# something else...)
	br	t0,1f				# After jmp, t0 will be pc of
1:	stq	t0,0(a0)			# <- this instruction.
	ret	zero,(ra)
	.end	__setjmp
