#include <syscall.h>
#include <signal.h>
#include <errno.h>

extern void ___sig_restore();
extern void ___masksig_restore();

int
__sigaction(int sig,struct sigaction * new, struct sigaction * old)
{
	if (new) {
		if (new->sa_flags & SA_NOMASK)
			new->sa_restorer=___sig_restore;
		else
			new->sa_restorer=___masksig_restore;
	}

	sig = syscall(SYS_sigaction, sig, new, old);
	if (sig>=0)
		return 0;
	errno = -sig;
	return -1;
}
