/* Copyright (C) 1992 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include <sysdeps/linux/sysdep.h>
#include <linux/alpha/regdef.h>
#include <linux/alpha/pal.h>

#ifndef LINUX_ALPHA_SYSDEP_H
#define LINUX_ALPHA_SYSDEP_H

#define ENTRY(name)                                                           \
  .globl _##name##;							      \
  .align 8;								      \
  _##name##:

/* Linux/AXP expects system calls from user mode to pass args as follows:
 *
 *	a0-a5 [$16-$21] - first six integer args
 *	v0 [$0] - System call number
 *
 * Outputs are returned as follows:
 *	a3 - Set if error, cleared otherwise.
 *	v0 - System call return value.
 */

/*
 * Note:  I took out the ## surrounding the 'name' parameter in the macro
 * below.  Apparently the GNU compiler treats them as the concatenation
 * operator and it was wreaking havoc.  bjn, 8/25/94.
 */

#define PSEUDO(name, syscall_name, args)                \
    .text;						\
    .align 8;						\
.globl	name;				\
name:						\
    lda		sp,-8(sp);				\
    stq		ra,0(sp);				\
    lda		v0,SYS_##syscall_name(zero);		\
    call_pal	PAL_callsys;				\
    beq		a3,Lexit;				\
    stl		v0,errno;				\
    lda		v0,-1(zero);				\
   Lexit:						\
    ldq		ra,0(sp);				\
    lda		sp,8(sp);

#define RETURN  ret zero,(ra)
/* Linux doesn't use it. */
#if 0
#define r0	$0
#define r1	$1
#define MOVE(x,y)       move x , y
#endif

#define RETSYS	ret zero,(ra)
#endif /* ALPHA_LINUX_SYSDEP_H */
